/* A Bison parser, made by GNU Bison 2.0a.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     LEFT_PAREN = 258,
     BEGIN_SYM = 259,
     PROCEDURE = 260,
     INDEX = 261,
     LENGTH = 262,
     ENDSTRUCTURE = 263,
     AND = 264,
     ARRAY = 265,
     BOOLEAN = 266,
     CASE = 267,
     DO = 268,
     ELSE = 269,
     END_SYM = 270,
     ENDCASE = 271,
     EXTERNAL = 272,
     FALSE = 273,
     FOR = 274,
     FUNCTION = 275,
     GO = 276,
     GOTO = 277,
     IF = 278,
     INTEGER = 279,
     LITERAL = 280,
     NOT = 281,
     OR = 282,
     OWN = 283,
     POINTER = 284,
     REAL = 285,
     RETURN = 286,
     STEP = 287,
     STRING = 288,
     STRUCTURE = 289,
     SUBSTRING = 290,
     TO = 291,
     THEN = 292,
     TRUE = 293,
     TYPE = 294,
     UNION = 295,
     UNTIL = 296,
     WHILE = 297,
     ARROW = 298,
     COLON = 299,
     COMMA = 300,
     CONCAT = 301,
     LONG = 302,
     SEMICOLON = 303,
     LEFT_MARK = 304,
     RIGHT_MARK = 305,
     RIGHT_PAREN = 306,
     ATSIGN = 307,
     QUOTEQUOTE = 308,
     STARSTAR = 309,
     ADD_OP = 310,
     MUL_OP = 311,
     REL_OP = 312,
     LOG_OP = 313,
     ID = 314,
     NAMED_VAR = 315,
     NAMED_BOOL = 316,
     NAMED_PTR = 317,
     NAMED_LABEL = 318,
     NAMED_STRING = 319,
     FUNCTION_ID = 320,
     BOOLEAN_ID = 321,
     PROC_ID = 322,
     STRING_ID = 323,
     NAMED_STRUCT = 324,
     USER_TYPE = 325,
     STRING_CONSTANT = 326,
     NUMERIC_CONSTANT = 327,
     COMMENT = 328
   };
#endif
#define LEFT_PAREN 258
#define BEGIN_SYM 259
#define PROCEDURE 260
#define INDEX 261
#define LENGTH 262
#define ENDSTRUCTURE 263
#define AND 264
#define ARRAY 265
#define BOOLEAN 266
#define CASE 267
#define DO 268
#define ELSE 269
#define END_SYM 270
#define ENDCASE 271
#define EXTERNAL 272
#define FALSE 273
#define FOR 274
#define FUNCTION 275
#define GO 276
#define GOTO 277
#define IF 278
#define INTEGER 279
#define LITERAL 280
#define NOT 281
#define OR 282
#define OWN 283
#define POINTER 284
#define REAL 285
#define RETURN 286
#define STEP 287
#define STRING 288
#define STRUCTURE 289
#define SUBSTRING 290
#define TO 291
#define THEN 292
#define TRUE 293
#define TYPE 294
#define UNION 295
#define UNTIL 296
#define WHILE 297
#define ARROW 298
#define COLON 299
#define COMMA 300
#define CONCAT 301
#define LONG 302
#define SEMICOLON 303
#define LEFT_MARK 304
#define RIGHT_MARK 305
#define RIGHT_PAREN 306
#define ATSIGN 307
#define QUOTEQUOTE 308
#define STARSTAR 309
#define ADD_OP 310
#define MUL_OP 311
#define REL_OP 312
#define LOG_OP 313
#define ID 314
#define NAMED_VAR 315
#define NAMED_BOOL 316
#define NAMED_PTR 317
#define NAMED_LABEL 318
#define NAMED_STRING 319
#define FUNCTION_ID 320
#define BOOLEAN_ID 321
#define PROC_ID 322
#define STRING_ID 323
#define NAMED_STRUCT 324
#define USER_TYPE 325
#define STRING_CONSTANT 326
#define NUMERIC_CONSTANT 327
#define COMMENT 328




/* Copy the first part of user declarations.  */
#line 1 "algol.y"

#include "algol.h"


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 237 "algol.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  else
#   define YYSIZE_T unsigned long int
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   650

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  74
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  50
/* YYNRULES -- Number of rules. */
#define YYNRULES  124
/* YYNRULES -- Number of states. */
#define YYNSTATES  242

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   328

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     8,    11,    13,    19,    23,    25,
      29,    31,    35,    38,    46,    53,    56,    58,    60,    62,
      64,    66,    68,    70,    72,    74,    76,    78,    80,    84,
      86,    89,    94,    98,   100,   104,   106,   108,   110,   112,
     114,   116,   118,   120,   122,   124,   126,   131,   136,   139,
     143,   146,   149,   151,   157,   162,   166,   169,   173,   179,
     185,   189,   193,   197,   201,   205,   209,   213,   217,   221,
     223,   225,   227,   229,   231,   240,   247,   252,   256,   258,
     260,   263,   269,   271,   273,   275,   277,   279,   281,   283,
     289,   294,   297,   299,   302,   304,   309,   311,   313,   317,
     321,   324,   326,   329,   333,   335,   337,   339,   342,   346,
     349,   354,   358,   362,   366,   370,   374,   376,   379,   381,
     383,   385,   387,   392,   396
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      75,     0,    -1,    76,    -1,    77,    82,    -1,    78,    79,
      -1,     4,    -1,    80,    82,    89,    82,    83,    -1,    89,
      82,    83,    -1,    83,    -1,    80,    82,    81,    -1,    81,
      -1,    85,    84,    86,    -1,    84,    86,    -1,    85,    84,
      10,    59,    49,   117,    50,    -1,    84,    10,    59,    49,
     117,    50,    -1,    82,    48,    -1,    48,    -1,    15,    -1,
      11,    -1,    24,    -1,    29,    -1,    30,    -1,    33,    -1,
      87,    -1,    90,    -1,    47,    -1,    28,    -1,    17,    -1,
      86,    45,    59,    -1,    59,    -1,    88,    15,    -1,    34,
      59,    49,    80,    -1,    89,    82,    91,    -1,    91,    -1,
      39,    84,    59,    -1,    92,    -1,    93,    -1,    97,    -1,
     100,    -1,   101,    -1,   102,    -1,   103,    -1,   104,    -1,
     116,    -1,    77,    -1,   109,    -1,    23,    94,    95,    96,
      -1,    23,    94,   121,    95,    -1,     3,   121,    -1,    51,
      37,    91,    -1,    51,    37,    -1,    14,    91,    -1,    14,
      -1,    19,    98,    99,    13,    91,    -1,    60,    43,   117,
      32,    -1,   117,    41,   117,    -1,    22,    63,    -1,    21,
      36,    63,    -1,    42,    94,    51,    13,    91,    -1,    41,
      94,    51,    13,    91,    -1,    60,    43,   117,    -1,    61,
      43,   121,    -1,    61,    43,   117,    -1,    64,    43,   105,
      -1,   106,    43,   105,    -1,   117,    46,    64,    -1,   105,
      46,   117,    -1,   105,    46,    64,    -1,   105,    46,   107,
      -1,    53,    -1,    71,    -1,    64,    -1,   107,    -1,   106,
      -1,    35,     3,    64,    45,   117,    45,   117,    51,    -1,
       6,     3,   105,    45,   105,    51,    -1,     7,     3,   105,
      51,    -1,   108,    45,   117,    -1,   117,    -1,    31,    -1,
      31,   111,    -1,    12,   118,    44,   114,    16,    -1,   121,
      -1,    69,    -1,   117,    -1,   105,    -1,    62,    -1,   112,
      -1,   110,    -1,    12,   105,    44,   113,    16,    -1,   105,
      44,    92,    48,    -1,   113,   112,    -1,   112,    -1,   114,
     115,    -1,   115,    -1,   117,    44,    92,    48,    -1,   112,
      -1,   110,    -1,   117,    55,   117,    -1,   117,    56,   117,
      -1,    55,   117,    -1,   118,    -1,   118,   119,    -1,     3,
     117,    51,    -1,    72,    -1,   120,    -1,    60,    -1,    52,
      62,    -1,   119,    54,   118,    -1,    54,   118,    -1,    65,
       3,   108,    51,    -1,    65,     3,    51,    -1,   121,    27,
     121,    -1,   121,     9,   121,    -1,   121,    58,   121,    -1,
     121,    57,   121,    -1,   122,    -1,    26,   122,    -1,   123,
      -1,    38,    -1,    18,    -1,    61,    -1,    66,     3,   108,
      51,    -1,    66,     3,    51,    -1,     3,   121,    51,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned char yyrline[] =
{
       0,    18,    18,    20,    22,    24,    26,    27,    29,    31,
      32,    34,    35,    37,    38,    40,    41,    43,    45,    46,
      47,    48,    49,    50,    51,    52,    54,    55,    57,    58,
      60,    62,    64,    65,    67,    69,    70,    71,    73,    74,
      75,    76,    77,    78,    79,    80,    82,    83,    85,    87,
      88,    89,    90,    92,    94,    96,    98,    99,   101,   103,
     105,   107,   108,   110,   112,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   124,   126,   127,   129,   130,   132,
     133,   135,   137,   138,   139,   140,   141,   142,   143,   145,
     146,   148,   149,   151,   153,   155,   157,   158,   160,   161,
     162,   163,   165,   167,   168,   169,   170,   171,   172,   173,
     175,   176,   178,   179,   180,   181,   182,   184,   185,   187,
     188,   189,   190,   191,   192
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "LEFT_PAREN", "BEGIN_SYM", "PROCEDURE",
  "INDEX", "LENGTH", "ENDSTRUCTURE", "AND", "ARRAY", "BOOLEAN", "CASE",
  "DO", "ELSE", "END_SYM", "ENDCASE", "EXTERNAL", "FALSE", "FOR",
  "FUNCTION", "GO", "GOTO", "IF", "INTEGER", "LITERAL", "NOT", "OR", "OWN",
  "POINTER", "REAL", "RETURN", "STEP", "STRING", "STRUCTURE", "SUBSTRING",
  "TO", "THEN", "TRUE", "TYPE", "UNION", "UNTIL", "WHILE", "ARROW",
  "COLON", "COMMA", "CONCAT", "LONG", "SEMICOLON", "LEFT_MARK",
  "RIGHT_MARK", "RIGHT_PAREN", "ATSIGN", "QUOTEQUOTE", "STARSTAR",
  "ADD_OP", "MUL_OP", "REL_OP", "LOG_OP", "ID", "NAMED_VAR", "NAMED_BOOL",
  "NAMED_PTR", "NAMED_LABEL", "NAMED_STRING", "FUNCTION_ID", "BOOLEAN_ID",
  "PROC_ID", "STRING_ID", "NAMED_STRUCT", "USER_TYPE", "STRING_CONSTANT",
  "NUMERIC_CONSTANT", "COMMENT", "$accept", "algol", "PROG", "block",
  "block_head", "end_part", "declare_list", "declare_stmt", "semi_list",
  "block_end", "data_type", "storage_type", "id_list", "structure_type",
  "structure_define", "stmt_list", "user_declare", "stmt", "any_stmt",
  "if_stmt", "bool_part", "then_part", "else_part", "for_stmt",
  "step_part", "step_part_2", "goto_stmt", "while_stmt", "until_stmt",
  "assign_stmt", "string_stmt", "string_val", "substring_proc",
  "string_function", "arg_list", "return_stmt", "arithmetic_case",
  "any_value", "string_case", "string_cases", "arith_cases", "arith_case",
  "case_stmt", "expression", "variable", "power_list", "function_call",
  "boolean_expr", "notted_boolean", "boolean_var", 0
};
#endif

/* INFRINGES ON USER NAME SPACE */
#ifndef _
# define _(msgid) msgid
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    74,    75,    76,    77,    78,    79,    79,    79,    80,
      80,    81,    81,    81,    81,    82,    82,    83,    84,    84,
      84,    84,    84,    84,    84,    84,    85,    85,    86,    86,
      87,    88,    89,    89,    90,    91,    91,    91,    92,    92,
      92,    92,    92,    92,    92,    92,    93,    93,    94,    95,
      95,    96,    96,    97,    98,    99,   100,   100,   101,   102,
     103,   103,   103,   104,   104,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   106,   107,   107,   108,   108,   109,
     109,   110,   111,   111,   111,   111,   111,   111,   111,   112,
     112,   113,   113,   114,   114,   115,   116,   116,   117,   117,
     117,   117,   117,   118,   118,   118,   118,   118,   119,   119,
     120,   120,   121,   121,   121,   121,   121,   122,   122,   123,
     123,   123,   123,   123,   123
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     2,     1,     5,     3,     1,     3,
       1,     3,     2,     7,     6,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       2,     4,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     4,     2,     3,
       2,     2,     1,     5,     4,     3,     2,     3,     5,     5,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     8,     6,     4,     3,     1,     1,
       2,     5,     1,     1,     1,     1,     1,     1,     1,     5,
       4,     2,     1,     2,     1,     4,     1,     1,     3,     3,
       2,     1,     2,     3,     1,     1,     1,     2,     3,     2,
       4,     3,     3,     3,     3,     3,     1,     2,     1,     1,
       1,     1,     4,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     5,     0,     2,     0,     0,     1,    16,     3,     0,
       0,     0,    18,     0,    17,    27,     0,     0,     0,     0,
      19,    26,    20,    21,    79,    22,     0,     0,     0,     0,
       0,    25,     0,    69,     0,   106,     0,    71,     0,    70,
     104,    44,     4,     0,    10,     8,     0,     0,    23,     0,
       0,    24,    33,    35,    36,    37,    38,    39,    40,    41,
      42,     0,    73,    72,    45,    97,    96,    43,     0,   101,
     105,    15,   106,     0,     0,     0,    71,     0,    73,   101,
       0,     0,     0,    56,     0,     0,     0,   120,     0,   119,
     121,    86,     0,    83,    85,    88,    80,    87,    84,    82,
     116,   118,     0,     0,     0,     0,     0,   107,   100,     0,
       0,     0,     0,     0,     0,    29,    12,     0,    30,     0,
       0,     0,     0,     0,     0,     0,     0,   102,   103,     0,
       0,     0,     0,     0,     0,     0,    57,     0,    48,     0,
       0,     0,     0,   117,     0,     0,     0,     0,     0,     0,
       0,    34,     0,     0,    60,    62,    61,    63,   111,     0,
      78,     9,     0,     0,     0,     0,    11,     7,    32,     0,
      67,    68,    66,    64,    65,    98,    99,   109,     0,     0,
      76,     0,    92,     0,     0,    94,     0,     0,     0,     0,
      50,    52,    46,    47,   124,   123,     0,   113,   112,   115,
     114,    31,     0,     0,     0,     0,   110,     0,     0,    28,
       0,    90,   108,     0,    89,    91,    81,    93,     0,    54,
      53,    55,    49,    51,   122,     0,     0,    59,    58,    77,
       6,     0,     0,    75,     0,     0,    14,     0,    95,     0,
      13,    74
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     2,     3,    41,     5,    42,    43,    44,     8,    45,
      46,    47,   116,    48,    49,    50,    51,    52,    53,    54,
      85,   140,   192,    55,    81,   134,    56,    57,    58,    59,
      60,    61,    62,    63,   159,    64,    65,    96,    66,   183,
     184,   185,    67,    68,    69,   127,    70,   142,   100,   101
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -117
static const short int yypact[] =
{
      20,  -117,    41,  -117,    -2,   183,  -117,  -117,     6,    87,
      71,    84,  -117,   505,  -117,  -117,    36,    72,    63,   145,
    -117,  -117,  -117,  -117,   393,  -117,     5,   148,   603,   145,
     145,  -117,   106,  -117,    87,   130,   140,   141,   182,  -117,
    -117,  -117,  -117,    -2,  -117,  -117,    12,   603,  -117,   173,
      -2,  -117,  -117,  -117,  -117,  -117,  -117,  -117,  -117,  -117,
    -117,    61,   149,  -117,  -117,  -117,  -117,  -117,     1,   137,
    -117,  -117,  -117,   107,   505,   505,  -117,    67,  -117,     4,
     158,    87,   146,  -117,    14,     0,   507,  -117,    14,  -117,
    -117,  -117,   200,  -117,    61,  -117,  -117,  -117,     1,    28,
    -117,  -117,   159,   165,   151,   180,   181,  -117,    88,    87,
     507,   505,    81,   246,   174,  -117,   189,    17,  -117,   309,
     463,   283,   505,   175,    87,    87,    62,   186,  -117,   109,
     -23,    85,    87,    87,   224,   -21,  -117,    14,    28,   204,
     228,     2,   170,  -117,   294,    14,    14,    14,    14,   592,
     201,  -117,   232,   238,    88,    88,    28,   210,  -117,   -15,
      88,  -117,    -2,   211,   202,   203,   189,  -117,  -117,   216,
    -117,  -117,    88,   210,  -117,    88,    88,  -117,    62,   505,
    -117,   505,  -117,   484,   526,  -117,   -13,   -11,   372,    87,
     372,   372,  -117,  -117,  -117,  -117,    38,    28,    28,    28,
      28,    -2,    87,   372,   372,    87,  -117,   309,    87,  -117,
     217,  -117,  -117,    27,  -117,  -117,  -117,  -117,   463,  -117,
    -117,    88,  -117,  -117,  -117,   571,    -6,  -117,  -117,    88,
    -117,   110,    87,  -117,   223,    87,  -117,   122,  -117,   164,
    -117,  -117
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -117,  -117,  -117,   259,  -117,  -117,   123,  -104,   -37,  -103,
     -14,  -117,   156,  -117,  -117,   169,  -117,  -109,  -116,  -117,
     152,   142,  -117,  -117,  -117,  -117,  -117,  -117,  -117,  -117,
    -117,    -5,   -12,   157,   147,  -117,   260,  -117,   -22,  -117,
    -117,   108,  -117,    -9,    -8,  -117,  -117,   -17,   207,  -117
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      73,    78,    97,   137,   169,    79,   113,    99,    77,   161,
     168,   145,    78,   119,   104,    98,   167,   137,    87,    94,
     189,   219,   114,   121,     1,   108,    88,   165,   180,   146,
     205,   218,    87,   117,   124,   125,   206,   145,    89,   235,
      88,     6,   124,   125,   124,   125,     7,   123,   132,   124,
     125,   139,    89,   139,    71,   146,   124,   125,   126,   147,
     148,    90,    78,    78,   102,     9,    92,   138,   141,   129,
     130,   115,   135,   121,    74,    90,   115,    73,   233,   220,
      92,   222,   223,   205,     9,   147,   148,    75,     9,   224,
       9,    10,    11,   156,   227,   228,    80,   181,   168,    78,
     154,   155,   234,   160,   230,   120,   157,   121,    82,   182,
      78,   131,   172,   121,    32,   175,   176,   173,   177,    78,
      27,   161,    72,   186,   187,   207,    83,    38,   197,   198,
     199,   200,   158,    32,    40,   160,    34,    32,    33,    32,
      34,    72,    34,   124,   125,    72,    38,    72,    84,    76,
      38,   103,    38,    40,   179,   121,    39,    40,   128,    40,
     236,   215,   124,   125,   225,   124,   125,    78,   107,    78,
     212,    78,   240,   109,   213,   186,    77,   124,   125,   145,
     221,   105,   106,   110,   111,   112,     9,     1,   118,    10,
      11,   126,   122,   226,    12,    13,   229,   146,    14,   231,
      15,   133,    16,   144,    17,    18,    19,    20,   149,   136,
     151,    21,    22,    23,    24,   241,    25,    26,    27,   124,
     125,   194,    28,   237,    29,    30,   239,   147,   148,   150,
      31,   152,   153,   163,   164,    32,    33,   188,    34,   174,
     178,   190,   191,    35,    36,   203,   202,    37,    38,     9,
       1,   204,    10,    11,    39,    40,   121,    12,    13,     4,
     208,   209,   210,    15,   211,    16,   232,    17,    18,    19,
      20,   238,   201,   166,    21,    22,    23,    24,   171,    25,
      26,    27,   162,   193,    95,    28,     9,    29,    30,    10,
      11,   196,   217,    31,    71,   143,     0,     9,    32,    33,
       0,    34,     0,     0,     0,     0,    35,    36,     0,     0,
      37,    38,     9,     1,     0,    10,    11,    39,    40,     0,
       0,    13,     0,     0,    14,     0,     0,     0,    16,     0,
      17,    18,    19,     0,     0,    32,     0,     0,    34,     0,
      24,     0,     0,    72,    27,   195,    32,   170,    38,    34,
      29,    30,     0,     0,    72,    40,     0,    71,     0,    38,
       0,    32,    33,     0,    34,     0,    40,     0,     0,    35,
      36,     0,     0,    37,    38,     9,     1,     0,    10,    11,
      39,    40,     0,     0,    13,     0,     0,     0,     0,     0,
       0,    16,     0,    17,    18,    19,    86,     0,     0,    10,
      11,     0,     0,    24,     0,    13,     0,    27,     0,     0,
       0,    87,     0,    29,    30,     0,     0,     0,     0,    88,
       0,     0,     0,     0,    32,    33,     0,    34,    27,     0,
       0,    89,    35,    36,     0,     0,    37,    38,     0,     0,
       0,     0,     0,    39,    40,    32,    33,     0,    34,     0,
       0,     0,     0,    72,    90,    91,     0,    76,    38,    92,
       0,     0,    93,     0,    39,    40,     9,     1,     0,    10,
      11,     0,     0,     0,     0,    13,     0,     0,     0,     0,
       0,     0,     0,     0,    17,    18,     0,     9,     0,     0,
      10,    11,     0,     0,    24,     0,   181,     0,    27,     0,
     214,     0,     0,     0,    29,    30,     0,     0,     9,     0,
      86,    10,    11,     0,     0,    32,    33,     0,    34,    27,
       0,     0,     0,    35,    36,    87,     0,    37,    38,     9,
       0,     0,     0,    88,    39,    40,    32,    33,     0,    34,
      27,     0,   216,     0,    72,    89,     0,     0,    76,    38,
       0,     0,     0,     0,     0,    39,    40,    32,    33,    32,
      34,     0,    34,     0,     0,    72,     0,    72,    90,    76,
      38,     0,    38,    92,     0,     0,    39,    40,    32,    40,
       0,    34,    12,     0,     0,     0,    72,     0,    15,     0,
       0,    38,     0,     0,     0,    20,     0,     0,    40,    21,
      22,    23,     0,    12,    25,    26,     0,     0,     0,    15,
      28,     0,     0,     0,    12,     0,    20,     0,    31,    71,
      21,    22,    23,     0,     0,    25,    26,    20,     0,     0,
       0,    28,    22,    23,     0,     0,    25,    26,     0,    31,
       0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
      31
};

static const short int yycheck[] =
{
       9,    13,    24,     3,   120,    13,    43,    24,    13,   113,
     119,     9,    24,    50,    28,    24,   119,     3,    18,    24,
      41,    32,    10,    46,     4,    34,    26,    10,    51,    27,
      45,    44,    18,    47,    55,    56,    51,     9,    38,    45,
      26,     0,    55,    56,    55,    56,    48,    46,    44,    55,
      56,    51,    38,    51,    48,    27,    55,    56,    54,    57,
      58,    61,    74,    75,    59,     3,    66,    84,    85,    74,
      75,    59,    81,    46,     3,    61,    59,    86,    51,   188,
      66,   190,   191,    45,     3,    57,    58,     3,     3,    51,
       3,     6,     7,   110,   203,   204,    60,    12,   207,   111,
     109,   110,   218,   112,   207,    44,   111,    46,    36,   131,
     122,    44,   121,    46,    52,   124,   125,   122,   126,   131,
      35,   225,    60,   132,   133,   162,    63,    65,   145,   146,
     147,   148,    51,    52,    72,   144,    55,    52,    53,    52,
      55,    60,    55,    55,    56,    60,    65,    60,     3,    64,
      65,     3,    65,    72,    45,    46,    71,    72,    51,    72,
      50,   183,    55,    56,   201,    55,    56,   179,    62,   181,
     178,   183,    50,    43,   179,   184,   181,    55,    56,     9,
     189,    29,    30,    43,    43,     3,     3,     4,    15,     6,
       7,    54,    43,   202,    11,    12,   205,    27,    15,   208,
      17,    43,    19,     3,    21,    22,    23,    24,    49,    63,
      59,    28,    29,    30,    31,    51,    33,    34,    35,    55,
      56,    51,    39,   232,    41,    42,   235,    57,    58,    64,
      47,    51,    51,    59,    45,    52,    53,    13,    55,    64,
      54,    37,    14,    60,    61,    13,    45,    64,    65,     3,
       4,    13,     6,     7,    71,    72,    46,    11,    12,     0,
      49,    59,    59,    17,    48,    19,    49,    21,    22,    23,
      24,    48,   149,   117,    28,    29,    30,    31,   121,    33,
      34,    35,   113,   141,    24,    39,     3,    41,    42,     6,
       7,   144,   184,    47,    48,    88,    -1,     3,    52,    53,
      -1,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,
      64,    65,     3,     4,    -1,     6,     7,    71,    72,    -1,
      -1,    12,    -1,    -1,    15,    -1,    -1,    -1,    19,    -1,
      21,    22,    23,    -1,    -1,    52,    -1,    -1,    55,    -1,
      31,    -1,    -1,    60,    35,    51,    52,    64,    65,    55,
      41,    42,    -1,    -1,    60,    72,    -1,    48,    -1,    65,
      -1,    52,    53,    -1,    55,    -1,    72,    -1,    -1,    60,
      61,    -1,    -1,    64,    65,     3,     4,    -1,     6,     7,
      71,    72,    -1,    -1,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    -1,    21,    22,    23,     3,    -1,    -1,     6,
       7,    -1,    -1,    31,    -1,    12,    -1,    35,    -1,    -1,
      -1,    18,    -1,    41,    42,    -1,    -1,    -1,    -1,    26,
      -1,    -1,    -1,    -1,    52,    53,    -1,    55,    35,    -1,
      -1,    38,    60,    61,    -1,    -1,    64,    65,    -1,    -1,
      -1,    -1,    -1,    71,    72,    52,    53,    -1,    55,    -1,
      -1,    -1,    -1,    60,    61,    62,    -1,    64,    65,    66,
      -1,    -1,    69,    -1,    71,    72,     3,     4,    -1,     6,
       7,    -1,    -1,    -1,    -1,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    22,    -1,     3,    -1,    -1,
       6,     7,    -1,    -1,    31,    -1,    12,    -1,    35,    -1,
      16,    -1,    -1,    -1,    41,    42,    -1,    -1,     3,    -1,
       3,     6,     7,    -1,    -1,    52,    53,    -1,    55,    35,
      -1,    -1,    -1,    60,    61,    18,    -1,    64,    65,     3,
      -1,    -1,    -1,    26,    71,    72,    52,    53,    -1,    55,
      35,    -1,    16,    -1,    60,    38,    -1,    -1,    64,    65,
      -1,    -1,    -1,    -1,    -1,    71,    72,    52,    53,    52,
      55,    -1,    55,    -1,    -1,    60,    -1,    60,    61,    64,
      65,    -1,    65,    66,    -1,    -1,    71,    72,    52,    72,
      -1,    55,    11,    -1,    -1,    -1,    60,    -1,    17,    -1,
      -1,    65,    -1,    -1,    -1,    24,    -1,    -1,    72,    28,
      29,    30,    -1,    11,    33,    34,    -1,    -1,    -1,    17,
      39,    -1,    -1,    -1,    11,    -1,    24,    -1,    47,    48,
      28,    29,    30,    -1,    -1,    33,    34,    24,    -1,    -1,
      -1,    39,    29,    30,    -1,    -1,    33,    34,    -1,    47,
      -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     4,    75,    76,    77,    78,     0,    48,    82,     3,
       6,     7,    11,    12,    15,    17,    19,    21,    22,    23,
      24,    28,    29,    30,    31,    33,    34,    35,    39,    41,
      42,    47,    52,    53,    55,    60,    61,    64,    65,    71,
      72,    77,    79,    80,    81,    83,    84,    85,    87,    88,
      89,    90,    91,    92,    93,    97,   100,   101,   102,   103,
     104,   105,   106,   107,   109,   110,   112,   116,   117,   118,
     120,    48,    60,   117,     3,     3,    64,   105,   106,   118,
      60,    98,    36,    63,     3,    94,     3,    18,    26,    38,
      61,    62,    66,    69,   105,   110,   111,   112,   117,   121,
     122,   123,    59,     3,    84,    94,    94,    62,   117,    43,
      43,    43,     3,    82,    10,    59,    86,    84,    15,    82,
      44,    46,    43,    46,    55,    56,    54,   119,    51,   105,
     105,    44,    44,    43,    99,   117,    63,     3,   121,    51,
      95,   121,   121,   122,     3,     9,    27,    57,    58,    49,
      64,    59,    51,    51,   117,   117,   121,   105,    51,   108,
     117,    81,    89,    59,    45,    10,    86,    83,    91,    92,
      64,   107,   117,   105,    64,   117,   117,   118,    54,    45,
      51,    12,   112,   113,   114,   115,   117,   117,    13,    41,
      37,    14,    96,    95,    51,    51,   108,   121,   121,   121,
     121,    80,    45,    13,    13,    45,    51,    82,    49,    59,
      59,    48,   118,   105,    16,   112,    16,   115,    44,    32,
      91,   117,    91,    91,    51,    82,   117,    91,    91,   117,
      83,   117,    49,    51,    92,    45,    50,   117,    48,   117,
      50,    51
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror (_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, _("Stack now"));
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, _("Reducing stack by rule %d (line %u), "),
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (_("parser stack overflow"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, _("Stack size increased to %lu\n"),
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, _("Entering state %d\n"), yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, _("Reading a token: ")));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, _("Now at end of input.\n")));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT (_("Next token is"), yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT (_("Shifting"), yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
      
      default: break;
    }

/* Line 1056 of yacc.c.  */
#line 1480 "algol.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yystrlen (yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  _("syntax error, unexpected %s");
	  _("syntax error, unexpected %s, expecting %s");
	  _("syntax error, unexpected %s, expecting %s or %s");
	  _("syntax error, unexpected %s, expecting %s or %s or %s");
	  _("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yystrlen (yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = _(yyformat);
	  yysize1 = yysize + strlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp = yystpcpy (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror (_("syntax error; also memory exhausted"));
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct (_("Error: discarding"), yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct (_("Error: popping"), yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT (_("Shifting"), yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror (_("parser stack overflow"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct (_("Error: discarding lookahead"),
		 yytoken, &yylval);
  if (yyssp != yyss)
    for (;;)
      {

	YYPOPSTACK;
	if (yyssp == yyss)
	  break;
	yydestruct (_("Error: popping"),
		    yystos[*yyssp], yyvsp);
      }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 195 "algol.y"


